create or replace
PROCEDURE FORMULA_ORCA (       P_NMTABELA       IN  TABELA.NMTABELABD%TYPE,
                               P_CDFILIAL       IN  FILIAL.CDFILIAL%TYPE,
                               P_NRORCAEVENTO   IN  ORCAEVENTO.NRORCAEVENTO%TYPE,
                               P_NRSEQORCAEVE   IN  ORCAEVENTO.NRSEQORCAEVE%TYPE,
                               P_CDARVPROD      IN  PRODUTO.CDARVPROD%TYPE,
                               P_QTPRODUTO      IN  NUMBER,
                               P_CDMENSERRO     OUT  VARCHAR2)
IS

    V_NRITEM          DOUBLE PRECISION;
    V_CDGRUPPROD      VARCHAR2(10);
    V_CDSUBGRPROD     VARCHAR2(10);
    V_IDORIGPRUNITORE VARCHAR2(1);
    V_VRPERACRITEMORC DOUBLE PRECISION;
    V_VRCUSTO         DOUBLE PRECISION;
BEGIN
   P_CDMENSERRO := '';
   IF P_NMTABELA = 'ITEMORCAEVEN' THEN

      SELECT IDORIGPRUNITORE, VRPERACRITEMORC
      INTO V_IDORIGPRUNITORE, V_VRPERACRITEMORC
      FROM PARAMORCAEVE;

      IF V_IDORIGPRUNITORE = 'P' THEN

         FOR C_PROD IN (SELECT PRODUTO.CDPRODUTO, ITEMPREBASE.VRITEPREBASE, PRODUTO.CDGRTOTAPROD
                          FROM PRODUTO, ITEMPREBASE, ORCAEVENTO
                         WHERE PRODUTO.CDARVPROD       = P_CDARVPROD
                           AND PRODUTO.CDPRODUTO       = ITEMPREBASE.CDPRODUTO
                           AND ITEMPREBASE.CDPRECOBASE = ORCAEVENTO.CDPRECOBASE
                           AND ORCAEVENTO.CDFILIAL     = P_CDFILIAL
                           AND ORCAEVENTO.NRORCAEVENTO = P_NRORCAEVENTO
                           AND ORCAEVENTO.NRSEQORCAEVE = P_NRSEQORCAEVE
                           AND NOT PRODUTO.CDPRODUTO IN (SELECT CDPRODUTO FROM ITEMORCAEVEN
                                         WHERE CDFILIAL     =  P_CDFILIAL
                                           AND NRORCAEVENTO =  P_NRORCAEVENTO
                                           AND NRSEQORCAEVE =  P_NRSEQORCAEVE)) LOOP

            SELECT DISTINCT
                   (CUSTO_PRODUTO_LCEST(DEPARTAMENTO.CDFILIPEDORC, PRODUTO.CDPRODUTO, PARAMORCAEVE.CDTIPOCUSTO, SYSDATE, SYSDATE, A.CDALMOX, A.CDLOCAL )) VRCUSTO
            INTO V_VRCUSTO
              FROM PRODUTO, PARAMORCAEVE, DEPARTAMENTO,
                  (SELECT DISTINCT
                          PARAMFILIAL.CDFILIAL, PRODFILI.CDPRODUTO,
                          CASE PARAMFILIAL.IDUTILALMOX WHEN 'S' THEN NVL(PRODFILI.CDALMOXPRCLI, PARAMFILIAL.CDALMOXARIFE) ELSE ' ' END CDALMOX,
                          CASE PARAMFILIAL.IDUTILLCESTQ WHEN 'S' THEN NVL(PRODFILI.CDLOCALPRCLI, PARAMFILIAL.CDLOCALESTOQ) ELSE ' ' END CDLOCAL
                     FROM PRODFILI, PARAMFILIAL, PRODUTO, DEPARTAMENTO
                    WHERE (PARAMFILIAL.CDFILIAL     = PRODFILI.CDFILIAL)
                      AND (PRODUTO.CDPRODUTO        = PRODFILI.CDPRODUTO)
                      AND (PRODUTO.CDDEPTPEDORC     = DEPARTAMENTO.CDDEPTO)
                      AND (PARAMFILIAL.CDFILIAL     = DEPARTAMENTO.CDFILIPEDORC)) A
             WHERE (PRODUTO.CDPRODUTO    = C_PROD.CDPRODUTO)
               AND (DEPARTAMENTO.CDDEPTO = PRODUTO.CDDEPTPEDORC)
               AND (A.CDFILIAL           = DEPARTAMENTO.CDFILIPEDORC)
               AND (A.CDPRODUTO          = PRODUTO.CDPRODUTO);

            SELECT MAX(NRITEMORCEVE) +1
              INTO V_NRITEM
              FROM ITEMORCAEVEN
             WHERE (CDFILIAL = P_CDFILIAL)
               AND (NRORCAEVENTO = P_NRORCAEVENTO)
               AND (NRSEQORCAEVE = P_NRSEQORCAEVE);

            BEGIN
               SELECT NV.CDGRUPPROD, NV.CDSUBGRPROD
                 INTO V_CDGRUPPROD,  V_CDSUBGRPROD
                 FROM PRODUTO PA, PRODUTO PB, PARAMORCAEVE PO, NVSUBGRPROD NV
                WHERE (PA.CDPRODUTO   = C_PROD.CDPRODUTO)
                  AND (NV.CDGRUPPROD  = PO.CDGRPRODRELORCA)
                  AND (NV.CDFILISUBGR = 'P')
                  AND (NV.CDPRODUTO   = PB.CDPRODUTO)
                  AND (PA.CDARVPROD BETWEEN PB.CDARVPROD AND PB.CDARVPROD || 'zzzzzzzzzzzzzzzzzzzz')
                  AND (LENGTH(PB.CDARVPROD) = (SELECT MAX(LENGTH(P1.CDARVPROD))
                                                 FROM PRODUTO P1, PRODUTO P2, PARAMORCAEVE PR, NVSUBGRPROD SU
                                                WHERE (SU.CDGRUPPROD  = PR.CDGRPRODRELORCA)
                                                  AND (SU.CDFILISUBGR = 'P')
                                                  AND (SU.CDPRODUTO   = P1.CDPRODUTO)
                                                  AND (P2.CDARVPROD BETWEEN P1.CDARVPROD AND P1.CDARVPROD || 'zzzzzzzzzzzzzzzzzzzz')
                                                  AND (P2.CDPRODUTO = PA.CDPRODUTO)));
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  P_CDMENSERRO := 'SEMGRUPO';
            END;

            INSERT INTO ITEMORCAEVEN
               (CDFILIAL,     NRORCAEVENTO, NRSEQORCAEVE, CDPRODUTO,
                QTITEMORCEVE, VRITEMORCEVE, CDGRTOTAPROD, NRITEMORCEVE,
                CDGRUPPRODREL, CDSUBGRPRODREL, VRCUSTOESTPROD)
            VALUES
               ( P_CDFILIAL,   P_NRORCAEVENTO,  P_NRSEQORCAEVE,  C_PROD.CDPRODUTO,
                 P_QTPRODUTO,  C_PROD.VRITEPREBASE,C_PROD.CDGRTOTAPROD, TO_CHAR(LPAD(V_NRITEM, 10, '0')),
                 V_CDGRUPPROD,  V_CDSUBGRPROD, V_VRCUSTO);

         END LOOP;
      ELSE
         --- Verifica o item adicionado quando esta parmetrizado para custo do produto ---
         FOR C_PROD IN (SELECT DISTINCT A.CDPRODUTO, A.CDGRTOTAPROD,
                                        (CUSTO_PRODUTO_LCEST(A.CDFILIAL, A.CDPRODUTO, PARAMORCAEVE.CDTIPOCUSTO, SYSDATE, SYSDATE, B.CDALMOX, B.CDLOCAL )) VRCUSTO
                          FROM (SELECT PRODUTO.CDPRODUTO, PRODUTO.CDDEPTPEDORC,
                                       PRODUTO.CDGRTOTAPROD, DEPARTAMENTO.CDFILIPEDORC AS CDFILIAL, PRODUTO.CDARVPROD
                                  FROM PRODUTO, DEPARTAMENTO
                                 WHERE DEPARTAMENTO.CDDEPTO = PRODUTO.CDDEPTPEDORC) A,
                               PARAMORCAEVE, DEPARTAMENTO , ORCAEVENTO,
                              (SELECT DISTINCT
                                      PARAMFILIAL.CDFILIAL, PRODFILI.CDPRODUTO,
                                      CASE PARAMFILIAL.IDUTILALMOX WHEN 'S' THEN NVL(PRODFILI.CDALMOXPRCLI, PARAMFILIAL.CDALMOXARIFE) ELSE ' ' END CDALMOX,
                                      CASE PARAMFILIAL.IDUTILLCESTQ WHEN 'S' THEN NVL(PRODFILI.CDLOCALPRCLI, PARAMFILIAL.CDLOCALESTOQ) ELSE ' ' END CDLOCAL
                                 FROM PRODFILI, PARAMFILIAL, PRODUTO, DEPARTAMENTO
                                WHERE PARAMFILIAL.CDFILIAL     = PRODFILI.CDFILIAL
                                  AND PRODUTO.CDPRODUTO        = PRODFILI.CDPRODUTO
                                  AND PRODUTO.CDDEPTPEDORC     = DEPARTAMENTO.CDDEPTO
                                  AND PARAMFILIAL.CDFILIAL     = DEPARTAMENTO.CDFILIPEDORC) B
                         WHERE A.CDARVPROD       = P_CDARVPROD
                           AND A.CDFILIAL = B.CDFILIAL(+)
                           AND A.CDPRODUTO = B.CDPRODUTO(+)
                           AND ORCAEVENTO.CDFILIAL     = P_CDFILIAL
                           AND ORCAEVENTO.NRORCAEVENTO = P_NRORCAEVENTO
                           AND ORCAEVENTO.NRSEQORCAEVE = P_NRSEQORCAEVE
                           AND NOT A.CDPRODUTO IN (SELECT CDPRODUTO FROM ITEMORCAEVEN
                                                          WHERE CDFILIAL     =  P_CDFILIAL
                                                            AND NRORCAEVENTO =  P_NRORCAEVENTO
                                                            AND NRSEQORCAEVE =  P_NRSEQORCAEVE)) LOOP

            SELECT MAX(NRITEMORCEVE) +1
              INTO V_NRITEM
              FROM ITEMORCAEVEN
             WHERE (CDFILIAL = P_CDFILIAL)
               AND (NRORCAEVENTO = P_NRORCAEVENTO)
               AND (NRSEQORCAEVE = P_NRSEQORCAEVE);

            BEGIN
               SELECT NV.CDGRUPPROD, NV.CDSUBGRPROD
                 INTO V_CDGRUPPROD,  V_CDSUBGRPROD
                 FROM PRODUTO PA, PRODUTO PB, PARAMORCAEVE PO, NVSUBGRPROD NV
                WHERE (PA.CDPRODUTO   = C_PROD.CDPRODUTO)
                  AND (NV.CDGRUPPROD  = PO.CDGRPRODRELORCA)
                  AND (NV.CDFILISUBGR = 'P')
                  AND (NV.CDPRODUTO   = PB.CDPRODUTO)
                  AND (PA.CDARVPROD BETWEEN PB.CDARVPROD AND PB.CDARVPROD || 'zzzzzzzzzzzzzzzzzzzz')
                  AND (LENGTH(PB.CDARVPROD) = (SELECT MAX(LENGTH(P1.CDARVPROD))
                                                 FROM PRODUTO P1, PRODUTO P2, PARAMORCAEVE PR, NVSUBGRPROD SU
                                                WHERE (SU.CDGRUPPROD  = PR.CDGRPRODRELORCA)
                                                  AND (SU.CDFILISUBGR = 'P')
                                                  AND (SU.CDPRODUTO   = P1.CDPRODUTO)
                                                  AND (P2.CDARVPROD BETWEEN P1.CDARVPROD AND P1.CDARVPROD || 'zzzzzzzzzzzzzzzzzzzz')
                                                  AND (P2.CDPRODUTO = PA.CDPRODUTO)));
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  P_CDMENSERRO := 'SEMGRUPO';
            END;

            INSERT INTO ITEMORCAEVEN
               (CDFILIAL,     NRORCAEVENTO, NRSEQORCAEVE, CDPRODUTO,
                QTITEMORCEVE, VRITEMORCEVE, CDGRTOTAPROD, NRITEMORCEVE,
                CDGRUPPRODREL, CDSUBGRPRODREL, VRCUSTOESTPROD)
            VALUES
               ( P_CDFILIAL,   P_NRORCAEVENTO,  P_NRSEQORCAEVE,      C_PROD.CDPRODUTO,
                 P_QTPRODUTO,  C_PROD.VRCUSTO + ((C_PROD.VRCUSTO * V_VRPERACRITEMORC) / 100),  C_PROD.CDGRTOTAPROD, TO_CHAR(LPAD(V_NRITEM, 10, '0')),
                 V_CDGRUPPROD, V_CDSUBGRPROD, C_PROD.VRCUSTO);

         END LOOP;

      END IF;

   END IF;
   IF P_NMTABELA = 'ITMAOOBRAORCA' THEN

         FOR C_PRODMAO IN (SELECT PRODUTO.CDPRODUTO, ITEMPREBASE.VRITEPREBASE, PRODUTO.CDGRTOTAPROD
                            FROM PRODUTO, ITEMPREBASE, ORCAEVENTO
                           WHERE PRODUTO.CDARVPROD       =  P_CDARVPROD
                             AND PRODUTO.CDPRODUTO       = ITEMPREBASE.CDPRODUTO
                             AND ITEMPREBASE.CDPRECOBASE = ORCAEVENTO.CDPREBAMOBRA
                             AND ORCAEVENTO.CDFILIAL     =  P_CDFILIAL
                             AND ORCAEVENTO.NRORCAEVENTO =  P_NRORCAEVENTO
                             AND ORCAEVENTO.NRSEQORCAEVE =  P_NRSEQORCAEVE
                             AND NOT PRODUTO.CDPRODUTO IN (SELECT CDPRODUTO FROM ITMAOOBRAORCA
                                                           WHERE CDFILIAL     =  P_CDFILIAL
                                                             AND NRORCAEVENTO =  P_NRORCAEVENTO
                                                             AND NRSEQORCAEVE =  P_NRSEQORCAEVE)) LOOP

            FOR C_TURNO IN (SELECT DISTINCT NRTURNO FROM ITMAOOBRAORCA
                            WHERE CDFILIAL     = P_CDFILIAL
                              AND NRORCAEVENTO = P_NRORCAEVENTO
                              AND NRSEQORCAEVE = P_NRORCAEVENTO) LOOP

               INSERT INTO ITMAOOBRAORCA
                  (CDFILIAL,    NRORCAEVENTO, NRSEQORCAEVE, CDPRODUTO,
                   QTPRODMOBRA, VRCOBRMOBRA,  NRTURNO,      CDGRTOTAPROD)
               VALUES
                  (P_CDFILIAL,  P_NRORCAEVENTO, P_NRSEQORCAEVE, C_PRODMAO.CDPRODUTO,
                   P_QTPRODUTO, C_PRODMAO.VRITEPREBASE, C_TURNO.NRTURNO, C_PRODMAO.CDGRTOTAPROD);
            END LOOP;

         END LOOP;

   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('FORMULA_ORCA','5.40.000'); END;
/